/*
	pseudoregs.c

	Support for generating code for targets using pseudo-register names,
	letting the C compiler do the actual scheduling.
*/ 

#include "stdpccts.h"
#include "swartypes.h"
#include "tuple.h"
#include "scheduler.h"
#include "spool.h"

int numspills;


static void
pseudoregsinit32(void)
{
	int i;

	/* Declare the pseudo register names */
	/* This avoids spilling altogether */
	Ctab();
	fprintf(Cout, "register p32_t reg0");
	for (i=1; i<(REGSAVAIL+MAXSPILLS); ++i)
		fprintf(Cout, ", reg%d", i);
	fprintf(Cout, ";\n\n");
}

void
pseudoregsinit(void)
{
	if (optcpu == GenericIA32)
		pseudoregsinit32();
}

